# do-list-v8-integration-gem
This is the Ruby gem to integrate with the v8 SOAP api of Do List.

Documentation for their v8 api: http://api.dolist.net/doc
Log in to their extranet to get an api key and accound id: https://extranet.dolist.net/Home.aspx
See the how to use section in this readme.


## Do List V8
The V8 platform is the Do List email and SMS marketing platform. It is a place to store contacts, collect and organise data and set up automatic mail deliveries and personalised messages.
For more info checkout: https://www.dolist.com/en/solutions/dolist-v8/


## This gem
This gem is exclusively to get an authorisation key and to use it to push new entries to the V8 platform.
The v8 api uses the AccountID and the AuthenticationKey from the use to generate an AuthenticationToken. This token restrains the use of the API to an hour after which another AuthenticationToken needs to be created.


## Installation

Add this line to your application's Gemfile:

```ruby
gem 'do-list-v8'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install do-list-v8


## How to use?
When your account gets created you need to get the AccountID and the AuthenticationKey. For that you need to log in to: https://extranet.dolist.net. When logged in, click on the `administration` tab in the top right corner.
Then click on the `2. Web services` that appear on the settings bar to the right in the `G. Documentation Services`.

Add the IP address of the server you are going to use to connect to their api. Then click on the manage keys tab and create a new key. When the key is created, click on the `see key button` and a popup appears with your ID and key. Save the AccountID and the AuthenticationKey. They will both be used in this gem.

When using this gem, create a new integration and pass it the AccountID and the AuthenticationKey that you got.
* `do_list = DoList::Integration.new(account_id: [AccountID], api_key: [AuthenticationKey])`

Pass it to a variable. Use the push_entry method each time you want to push an entry to the Do List V8 platform.
* `do_list.push_entry(fields)`

The push_entry method needs an array with the following key-value pairs. All other key-value pairs will be added as extra fields.

### Required
`email: 'example@mail.com'`

### Optional
`mail_opt_out: 1`       -- `0 = opt in`  --  `1 = opt out` --
`mobile_opt_out: 0`     -- `0 = opt in`  --  `1 = opt out` --
when not specified they fall back to 0.


## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).


## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/emocial/do-list-v8.
If anyone is interested in improving this gem, please don't hesitate to fork and send pull requests ;)
Look in their v8 documentation (http://api.dolist.net/doc) to see the api methods that aren't added to this gem yet.


## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Contributors

* Roan Mertens - https://github.com/RoanMertens
